package schedframe.scheduling.plan.impl;

import java.io.StringWriter;

import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.ValidationException;

import schedframe.scheduling.plan.ParameterTypeInterface;
import schedframe.scheduling.plan.ParameterPropertyInterface;

public class ParameterType implements ParameterTypeInterface<
								org.qcg.broker.schemas.schedulingplan.ParameterType>{

	private static final long serialVersionUID = 3808756887675318177L;
	protected org.qcg.broker.schemas.schedulingplan.ParameterType pt;
	
	public ParameterType(){
		pt = new org.qcg.broker.schemas.schedulingplan.ParameterType();
	}

	public ParameterType(org.qcg.broker.schemas.schedulingplan.ParameterType value){
		pt = value;
	}
	
	public org.qcg.broker.schemas.schedulingplan.ParameterType getDescription() {
		return pt;
	}

	public String getDocument() {
		StringWriter writer = new StringWriter();
		try {
			pt.marshal(writer);
		} catch (MarshalException e) {
			e.printStackTrace();
		} catch (ValidationException e) {
			e.printStackTrace();
		}
		return writer.toString();
	}

	public void addParamValue(String paramValue)
			throws IndexOutOfBoundsException {
		pt.addParamValue(paramValue);
	}

	public void addParamValue(int index, String paramValue)
			throws IndexOutOfBoundsException {
		pt.addParamValue(index, paramValue);
	}

	public <Property_> void addProperty(ParameterPropertyInterface<Property_> property)
			throws IndexOutOfBoundsException {
		pt.addParameterProperty((org.qcg.broker.schemas.schedulingplan.ParameterProperty)property.getDescription());
	}

	public <Property_> void addProperty(int index, ParameterPropertyInterface<Property_> property)
			throws IndexOutOfBoundsException {
		pt.addParameterProperty(index,(org.qcg.broker.schemas.schedulingplan.ParameterProperty) property.getDescription());
	}

	public String getParamValue(int index) throws IndexOutOfBoundsException {
		return pt.getParamValue(index);
	}

	public String[] getParamValue() {
		return pt.getParamValue();
	}

	public int getParamValueCount() {
		return pt.getParamValueCount();
	}

	@SuppressWarnings("unchecked")
	public ParameterPropertyInterface<org.qcg.broker.schemas.schedulingplan.ParameterProperty> getProperty(int index)
			throws IndexOutOfBoundsException {
		return new schedframe.scheduling.plan.impl.ParameterProperty(pt.getParameterProperty(index));
	}

	@SuppressWarnings("unchecked")
	public ParameterPropertyInterface<org.qcg.broker.schemas.schedulingplan.ParameterProperty>[] getProperty() {
		org.qcg.broker.schemas.schedulingplan.ParameterProperty tab[] = pt.getParameterProperty();
		if(tab == null) return null;
		
		schedframe.scheduling.plan.impl.ParameterProperty ret[] = new schedframe.scheduling.plan.impl.ParameterProperty[tab.length];
		for(int i = 0; i < tab.length; i++){
			ret[i] = new schedframe.scheduling.plan.impl.ParameterProperty(tab[i]);
		}
		
		return ret;
	}

	public int getPropertyCount() {
		return pt.getParameterPropertyCount();
	}

	public void removeAllParamValue() {
		pt.removeAllParamValue();
	}

	public void removeAllProperty() {
		pt.removeAllParameterProperty();
	}

	public boolean removeParamValue(String paramValue) {
		return pt.removeParamValue(paramValue);
	}

	public String removeParamValueAt(int index) {
		return pt.removeParamValueAt(index);
	}

	public <Property_> boolean removeProperty(ParameterPropertyInterface<Property_> property) {
		return pt.removeParameterProperty((org.qcg.broker.schemas.schedulingplan.ParameterProperty)property.getDescription());
	}

	@SuppressWarnings("unchecked")
	public ParameterPropertyInterface<org.qcg.broker.schemas.schedulingplan.ParameterProperty> removePropertyAt(int index) {
		return new schedframe.scheduling.plan.impl.ParameterProperty(pt.removeParameterPropertyAt(index));
	}

	public void setParamValue(int index, String paramValue)
			throws IndexOutOfBoundsException {
		pt.setParamValue(index, paramValue);
	}

	public void setParamValue(String[] paramValueArray) {
		pt.setParamValue(paramValueArray);
	}

	public <Property_> void setProperty(int index, ParameterPropertyInterface<Property_> property)
			throws IndexOutOfBoundsException {
		pt.setParameterProperty(index, (org.qcg.broker.schemas.schedulingplan.ParameterProperty)property.getDescription());
	}

	public <Property_> void setProperty(ParameterPropertyInterface<Property_>[] propertyArray) {
		if(propertyArray == null)
			return;
		org.qcg.broker.schemas.schedulingplan.ParameterProperty tab[] = new org.qcg.broker.schemas.schedulingplan.ParameterProperty[propertyArray.length];
		for(int i = 0; i < propertyArray.length; i++){
			tab[i] = (org.qcg.broker.schemas.schedulingplan.ParameterProperty)propertyArray[i].getDescription();
		}
		pt.setParameterProperty(tab);
	}

}
