package simulator.reader;

import org.qcg.broker.schemas.exception.UnknownParameter;

import schemas.ComputingResource;
import schemas.ComputingResourceTypeChoiceSequence;
import schemas.ComputingResourceTypeChoiceSequence2;

public class ComputingResourceWrapper {
	
	ComputingResource computingResource;
	
	public void wrap(ComputingResource computingResource) {
		this.computingResource = computingResource;
	}
	
	public long getChildCount(){
		long compResCount = computingResource.getCount() > 1 ? computingResource.getCount() : 1;
		return compResCount;
	}

	public ComputingResourceTypeChoiceSequence getCharacteristics() throws UnknownParameter {
		if(computingResource.getComputingResourceTypeChoiceSequence() == null)
			throw new UnknownParameter("Characeristics are not defined.");
		return computingResource.getComputingResourceTypeChoiceSequence();
	}
	
	public ComputingResourceTypeChoiceSequence2 getTemplate() throws UnknownParameter {
		if(computingResource.getComputingResourceTypeChoiceSequence2() == null)
			throw new UnknownParameter("Templates are not defined.");
		return computingResource.getComputingResourceTypeChoiceSequence2();
	}

	public String getResourceClass(){
		return this.computingResource.getClazz();
	}
	
	public String getName(){
		return this.computingResource.getName();
	}
	
	public long getGroupId(){
		return this.computingResource.getGroupId();
	}
}
