package simulator.stats;


/**
 * Gathers the statistics values used internally
 * @author Stanislaw Szczepanowski
 */
public class StatisticsInfo {

	/** The mean value */
	protected GSSAccumulator mean;
	/** The standard deviation value */
	protected GSSAccumulator stdev;
	/** The minimal value */
	protected GSSAccumulator max;
	/** The maximal value */
	protected GSSAccumulator min;
	/**
	 * @param mean
	 * @param stdev
	 * @param max
	 * @param min
	 */
	public StatisticsInfo(GSSAccumulator mean, GSSAccumulator stdev, GSSAccumulator max, GSSAccumulator min) {
		this.mean = mean;
		this.stdev = stdev;
		this.max = max;
		this.min = min;
	}
	/**
	 * @return the maximal value
	 */
	public GSSAccumulator getMax() {
		return max;
	}
	/**
	 * @return the mean value
	 */
	public GSSAccumulator getMean() {
		return mean;
	}
	/**
	 * @return the minimal value
	 */
	public GSSAccumulator getMin() {
		return min;
	}
	/**
	 * @return the standard deviation value
	 */
	public GSSAccumulator getStdev() {
		return stdev;
	}
}